#ifdef __linux__

#include "stdafx.h"

#else

#include <string>
#include <exception>
#include <Isolator.h>
#include <gtest/gtest.h>
using namespace std;

#endif

#include "../ClassesUnderTest/GPSLocation.h"

// Isolator++ can enable you to call private methods without changing your production code
class InvokeMember : public ::testing::Test
{
public:
	virtual void TearDown() 
	{
		ISOLATOR_CLEANUP();
	}
};

/*****************************************
	Calling private members on real objects
******************************************/

TEST_F(InvokeMember, CallStaticPrivateMethod)
{
	bool res = false;
	ISOLATOR_INVOKE_FUNCTION(res, _, GPSLocation::IsGPSFound, 10, 10);
	
	ASSERT_EQ(true, res);
}
